file = {}

function file.Exists(filename)
	local file = io.open(filename)
	if file then
		io.close(file)
		return true
	else
		return false
	end
end

function file.Read(filename)
	if not file.Exists(filename) then return "" end
	local file = assert(io.open(filename, "r+"))
	local read = file:read("*all")
	file:close()
	return read
end

function file.Find(dir)
	dir = string.replace(dir, "/", "\\")
	local files = {}
	for i in io.popen("dir ".. dir):lines() do
		local filename = string.sub(i, 37)
		if string.len(string.trim(filename)) > 0 then
			table.insert(files, filename)
		end
	end
	table.remove(files, 1)
	table.remove(files, 1)
	table.remove(files, 1)
	table.remove(files, #files)
	table.remove(files, #files)
	return files
end

function file.Write(filename, text, mode)
	if mode == nil then mode = "w" end
	local file = assert(io.open(filename, mode))
	file:write(text)
	file:close()
end

function file.Lines(filename)
	if not file.Exists(filename) then return {} end
	local file = assert(io.open(filename, "r+"))
	return file:lines()
end

function file.Size(filename)
	if not file.Exists(filename) then return 0 end
	local file = assert(io.open(filename, "r+"))
	local current = file:seek()
	local size = file:seek("end")
	file:seek("set", current)
	file:close()
	return size
end

function file.Rename(oldname, newname)
	if not file.Exists(oldname) then return end
	if file.Exists(newname) then return end
	os.rename(oldname, newname)
end

function file.Delete(filename)
	if not file.Exists(filename) then return end
	os.remove(filename)
end
